diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 8f3b0de2..17569777 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -1085,17 +1301,36 @@ class SquadService extends Actor {
     }
   }
 
+  def InitSquadDetail(squad : Squad) : Unit = {
+    InitSquadDetail(squad.GUID, squad.Membership.map { member => member.CharId }, squad)
+  }
+
+  def InitSquadDetail(guid : PlanetSideGUID, squad : Squad) : Unit = {
+    InitSquadDetail(guid, squad.Membership.map { member => member.CharId }, squad)
+  }
+
+  def InitSquadDetail(guid : PlanetSideGUID, toMembers : Iterable[Long], squad : Squad) : Unit = {
+    val output = SquadResponse.Detail(guid, SquadService.Detail.Publish(squad))
+    toMembers.foreach { charId => SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", output)) }
+  }
+
   def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad) : Unit = {
     UpdateSquadDetail(guid, squad, SquadService.Detail.Publish(squad))
   }
 
-  def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad, detail : SquadDetail) : Unit = {
-    val output = SquadResponse.Detail(guid, detail)
-    squad.Membership
-      .filter { _.CharId > 0L }
-      .foreach { member =>
-        SquadEvents.publish(SquadServiceResponse(s"/${member.CharId}/Squad", output))
-      }
+  def UpdateSquadDetail(squad : Squad, details : SquadDetail) : Unit = {
+    UpdateSquadDetail(squad.GUID, squad.Membership.map { member => member.CharId }, details)
+  }
+
+  def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad, details : SquadDetail) : Unit = {
+    UpdateSquadDetail(guid, squad.Membership.map { member => member.CharId }, details)
+  }
+
+  def UpdateSquadDetail(guid : PlanetSideGUID, toMembers : Iterable[Long], details : SquadDetail) : Unit = {
+    if(toMembers.nonEmpty) {
+      val output = SquadResponse.Detail(guid, details)
+      toMembers.foreach { charId => SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", output)) }
+    }
   }
 }
 
@@ -1105,12 +1340,31 @@ object SquadService {
     def InviterName : String = name
   }
 
+  /**
+    * Utilized when one player attempts to join an existing squad in a specific role.
+    * @param player na
+    * @param squad_guid na
+    * @param position na
+    */
   final case class BidForPosition(player : Player, squad_guid : PlanetSideGUID, position : Int)
     extends Invitation(player.CharId, player.Name)
 
+  /**
+    * Utilized when one squad member issues an invite for some other player.
+    * @param char_id na
+    * @param name na
+    * @param squad_guid na
+    */
   final case class VacancyInvite(char_id : Long, name : String, squad_guid : PlanetSideGUID)
     extends Invitation(char_id, name)
 
+  final case class IndirectVacancy(player : Player, squad_guid : PlanetSideGUID)
+    extends Invitation(player.CharId, player.Name)
+
+  /**
+    * Utilized when one player issues an invite for some other player for a squad that does not yet exist.
+    * @param player na
+    */
   final case class SpontaneousInvite(player : Player)
     extends Invitation(player.CharId, player.Name)
 
@@ -1130,6 +1384,7 @@ object SquadService {
   object Detail {
     def Publish(squad : Squad) : SquadDetail = {
       SquadDetail()
+        .Field1(squad.GUID.guid)
         .LeaderCharId(squad.Leader.CharId)
         .LeaderName(squad.Leader.Name)
         .Task(squad.Task)
diff --git a/pslogin/src/main/scala/WorldSessionActor.scala b/pslogin/src/main/scala/WorldSessionActor.scala
index a7bbe9ef..8eadcead 100644
--- a/pslogin/src/main/scala/WorldSessionActor.scala
+++ b/pslogin/src/main/scala/WorldSessionActor.scala
@@ -379,8 +379,10 @@ class WorldSessionActor extends Actor with MDCContextAware {
         case SquadResponse.Detail(guid, detail) =>
           sendResponse(SquadDetailDefinitionUpdateMessage(guid, detail))
 
-        case SquadResponse.InitSquad(squad_guid) =>
-          sendResponse(SquadDefinitionActionMessage(squad_guid, 0, SquadAction.Unknown(16)))
+        case SquadResponse.AssociateWithSquad(squad_guid) =>
+          sendResponse(SquadDefinitionActionMessage(squad_guid, 0, SquadAction.AssociateWithSquad()))
+
+        case SquadResponse.SetListSquad(squad_guid) =>
           sendResponse(SquadDefinitionActionMessage(squad_guid, 0, SquadAction.SetListSquad()))
 
         case SquadResponse.Unknown17(squad, char_id) =>
@@ -3010,7 +3012,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
       sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), line, SquadAction.ListSquadFavorite("")))
     })
     sendResponse(SquadDetailDefinitionUpdateMessage.Init)
-    sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0,SquadAction.Unknown(16)))
+    sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0,SquadAction.AssociateWithSquad()))
     sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0,SquadAction.SetListSquad()))
     sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0,SquadAction.Unknown(18)))
     //MapObjectStateBlockMessage and ObjectCreateMessage?
@@ -3108,6 +3110,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
       avatar.Certifications += AssaultEngineering
       avatar.Certifications += Hacking
       avatar.Certifications += AdvancedHacking
+      avatar.CEP = 6000001
       this.avatar = avatar
 
       InitializeDeployableQuantities(avatar) //set deployables ui elements
@@ -4957,7 +4960,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
 
     case msg @ SquadDefinitionActionMessage(u1, u2, action) =>
       log.info(s"SquadDefinitionAction: $msg")
-        squadService ! SquadServiceMessage(player, SquadServiceAction.Definition(player, continent.Number, u1, u2, action))
+        squadService ! SquadServiceMessage(player, SquadServiceAction.Definition(player, continent, u1, u2, action))
 
     case msg @ SquadMembershipRequest(request_type, unk2, unk3, player_name, unk5) =>
       log.info(s"$msg")

